"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertInstructionExtraArgsNode = exports.isInstructionExtraArgsNode = exports.instructionExtraArgsNode = void 0;
const shared_1 = require("../shared");
function instructionExtraArgsNode(input) {
    if (!input.name) {
        throw new shared_1.InvalidKinobiTreeError('InstructionExtraArgsNode must have a name.');
    }
    return {
        kind: 'instructionExtraArgsNode',
        name: (0, shared_1.mainCase)(input.name),
        struct: input.struct,
        link: input.link,
    };
}
exports.instructionExtraArgsNode = instructionExtraArgsNode;
function isInstructionExtraArgsNode(node) {
    return !!node && node.kind === 'instructionExtraArgsNode';
}
exports.isInstructionExtraArgsNode = isInstructionExtraArgsNode;
function assertInstructionExtraArgsNode(node) {
    var _a;
    if (!isInstructionExtraArgsNode(node)) {
        throw new Error(`Expected instructionExtraArgsNode, got ${(_a = node === null || node === void 0 ? void 0 : node.kind) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertInstructionExtraArgsNode = assertInstructionExtraArgsNode;
//# sourceMappingURL=InstructionExtraArgsNode.js.map