"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertOptionTypeNode = exports.isOptionTypeNode = exports.optionTypeNodeFromIdl = exports.optionTypeNode = void 0;
const NumberTypeNode_1 = require("./NumberTypeNode");
const TypeNode_1 = require("./TypeNode");
function optionTypeNode(child, options = {}) {
    var _a, _b, _c;
    return {
        kind: 'optionTypeNode',
        child,
        prefix: (_a = options.prefix) !== null && _a !== void 0 ? _a : (0, NumberTypeNode_1.numberTypeNode)('u8'),
        fixed: (_b = options.fixed) !== null && _b !== void 0 ? _b : false,
        idlOption: (_c = options.idlOption) !== null && _c !== void 0 ? _c : 'option',
    };
}
exports.optionTypeNode = optionTypeNode;
function optionTypeNodeFromIdl(idl) {
    const child = 'option' in idl ? idl.option : idl.coption;
    const defaultPrefix = (0, NumberTypeNode_1.numberTypeNode)('option' in idl ? 'u8' : 'u32');
    const defaultFixed = !('option' in idl);
    return optionTypeNode((0, TypeNode_1.createTypeNodeFromIdl)(child), {
        prefix: idl.prefix ? (0, NumberTypeNode_1.numberTypeNode)(idl.prefix) : defaultPrefix,
        fixed: idl.fixed !== undefined ? idl.fixed : defaultFixed,
        idlOption: 'option' in idl ? 'option' : 'coption',
    });
}
exports.optionTypeNodeFromIdl = optionTypeNodeFromIdl;
function isOptionTypeNode(node) {
    return !!node && node.kind === 'optionTypeNode';
}
exports.isOptionTypeNode = isOptionTypeNode;
function assertOptionTypeNode(node) {
    var _a;
    if (!isOptionTypeNode(node)) {
        throw new Error(`Expected optionTypeNode, got ${(_a = node === null || node === void 0 ? void 0 : node.kind) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertOptionTypeNode = assertOptionTypeNode;
//# sourceMappingURL=OptionTypeNode.js.map