"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertTupleTypeNode = exports.isTupleTypeNode = exports.tupleTypeNodeFromIdl = exports.tupleTypeNode = void 0;
const TypeNode_1 = require("./TypeNode");
function tupleTypeNode(children) {
    return { kind: 'tupleTypeNode', children };
}
exports.tupleTypeNode = tupleTypeNode;
function tupleTypeNodeFromIdl(idl) {
    return tupleTypeNode(idl.tuple.map(TypeNode_1.createTypeNodeFromIdl));
}
exports.tupleTypeNodeFromIdl = tupleTypeNodeFromIdl;
function isTupleTypeNode(node) {
    return !!node && node.kind === 'tupleTypeNode';
}
exports.isTupleTypeNode = isTupleTypeNode;
function assertTupleTypeNode(node) {
    var _a;
    if (!isTupleTypeNode(node)) {
        throw new Error(`Expected tupleTypeNode, got ${(_a = node === null || node === void 0 ? void 0 : node.kind) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertTupleTypeNode = assertTupleTypeNode;
//# sourceMappingURL=TupleTypeNode.js.map