"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransformU8ArraysToBytesVisitor = void 0;
const shared_1 = require("../../shared");
const nodes = __importStar(require("../../nodes"));
const BaseNodeVisitor_1 = require("../BaseNodeVisitor");
const Visitor_1 = require("../Visitor");
class TransformU8ArraysToBytesVisitor extends BaseNodeVisitor_1.BaseNodeVisitor {
    constructor(sizes = [32, 64]) {
        super();
        this.sizes = sizes;
    }
    visitArrayType(arrayType) {
        const child = (0, Visitor_1.visit)(arrayType.child, this);
        nodes.assertTypeNode(child);
        if (nodes.isNumberTypeNode(child) &&
            child.format === 'u8' &&
            arrayType.size.kind === 'fixed' &&
            this.hasRequiredSize(arrayType.size)) {
            return nodes.bytesTypeNode((0, shared_1.fixedSize)(arrayType.size.value));
        }
        return nodes.arrayTypeNode(child, { ...arrayType });
    }
    hasRequiredSize(size) {
        if (size.kind !== 'fixed')
            return false;
        return this.sizes === '*' || this.sizes.includes(size.value);
    }
}
exports.TransformU8ArraysToBytesVisitor = TransformU8ArraysToBytesVisitor;
//# sourceMappingURL=TransformU8ArraysToBytesVisitor.js.map