"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnwrapTupleEnumWithSingleStructVisitor = void 0;
const nodes = __importStar(require("../../nodes"));
const BaseThrowVisitor_1 = require("../BaseThrowVisitor");
const Visitor_1 = require("../Visitor");
const aggregators_1 = require("../aggregators");
const TransformNodesVisitor_1 = require("./TransformNodesVisitor");
const UnwrapDefinedTypesVisitor_1 = require("./UnwrapDefinedTypesVisitor");
class UnwrapTupleEnumWithSingleStructVisitor extends BaseThrowVisitor_1.BaseThrowVisitor {
    constructor(enumsOrVariantsToUnwrap = '*') {
        super();
        this.enumsOrVariantsToUnwrap = enumsOrVariantsToUnwrap;
        this.enumsOrVariantsToUnwrap = enumsOrVariantsToUnwrap;
    }
    shouldUnwrap(node, stack) {
        const stackWithNode = stack.clone();
        stackWithNode.push(node);
        if (this.enumsOrVariantsToUnwrap === '*')
            return true;
        return this.enumsOrVariantsToUnwrap.some((selector) => stackWithNode.matchesWithNames(selector.split('.')));
    }
    visitRoot(root) {
        const typesToPotentiallyUnwrap = [];
        const definedTypes = new Map();
        nodes.getAllDefinedTypes(root).forEach((definedType) => {
            definedTypes.set(definedType.name, definedType);
        });
        let newRoot = (0, Visitor_1.visit)(root, new TransformNodesVisitor_1.TransformNodesVisitor([
            {
                selector: { kind: 'enumTupleVariantTypeNode' },
                transformer: (node, stack) => {
                    nodes.assertEnumTupleVariantTypeNode(node);
                    if (!this.shouldUnwrap(node, stack))
                        return node;
                    if (node.tuple.children.length !== 1)
                        return node;
                    let child = node.tuple.children[0];
                    if (nodes.isLinkTypeNode(child)) {
                        if (child.importFrom !== 'generated')
                            return node;
                        const definedType = definedTypes.get(child.name);
                        if (!definedType)
                            return node;
                        if (!nodes.isStructTypeNode(definedType.data))
                            return node;
                        typesToPotentiallyUnwrap.push(child.name);
                        child = definedType.data;
                    }
                    if (!nodes.isStructTypeNode(child))
                        return node;
                    return nodes.enumStructVariantTypeNode(node.name, child);
                },
            },
        ]));
        nodes.assertRootNode(newRoot);
        const histogram = (0, Visitor_1.visit)(newRoot, new aggregators_1.GetDefinedTypeHistogramVisitor());
        const typesToUnwrap = typesToPotentiallyUnwrap.filter((type) => !histogram[type] || histogram[type].total === 0);
        newRoot = (0, Visitor_1.visit)(newRoot, new UnwrapDefinedTypesVisitor_1.UnwrapDefinedTypesVisitor(typesToUnwrap));
        nodes.assertRootNode(newRoot);
        return newRoot;
    }
}
exports.UnwrapTupleEnumWithSingleStructVisitor = UnwrapTupleEnumWithSingleStructVisitor;
//# sourceMappingURL=UnwrapTupleEnumWithSingleStructVisitor.js.map