"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateDefinedTypesVisitor = void 0;
const nodes = __importStar(require("../../nodes"));
const shared_1 = require("../../shared");
const TransformNodesVisitor_1 = require("./TransformNodesVisitor");
const _renameHelpers_1 = require("./_renameHelpers");
class UpdateDefinedTypesVisitor extends TransformNodesVisitor_1.TransformNodesVisitor {
    constructor(map) {
        super(Object.entries(map).flatMap(([selector, updates]) => {
            const selectorStack = selector.split('.');
            const name = selectorStack.pop();
            const newName = typeof updates === 'object' && 'name' in updates && updates.name
                ? (0, shared_1.mainCase)(updates.name)
                : undefined;
            const transforms = [
                {
                    selector: { kind: 'definedTypeNode', stack: selectorStack, name },
                    transformer: (node, stack, program) => {
                        nodes.assertDefinedTypeNode(node);
                        if (typeof updates === 'function') {
                            return updates(node, stack, program);
                        }
                        if ('delete' in updates) {
                            return null;
                        }
                        const { data: dataUpdates, ...otherUpdates } = updates;
                        let newData = node.data;
                        if (nodes.isStructTypeNode(node.data)) {
                            newData = (0, _renameHelpers_1.renameStructNode)(node.data, dataUpdates !== null && dataUpdates !== void 0 ? dataUpdates : {});
                        }
                        else if (nodes.isEnumTypeNode(node.data)) {
                            newData = (0, _renameHelpers_1.renameEnumNode)(node.data, dataUpdates !== null && dataUpdates !== void 0 ? dataUpdates : {});
                        }
                        return nodes.definedTypeNode({
                            ...node,
                            ...otherUpdates,
                            name: newName !== null && newName !== void 0 ? newName : node.name,
                            data: newData,
                        });
                    },
                },
            ];
            if (newName) {
                transforms.push({
                    selector: {
                        kind: 'linkTypeNode',
                        stack: selectorStack,
                        name,
                    },
                    transformer: (node) => {
                        nodes.assertLinkTypeNode(node);
                        if (node.importFrom !== 'generated')
                            return node;
                        return nodes.linkTypeNode(newName, { ...node });
                    },
                });
            }
            return transforms;
        }));
        this.map = map;
    }
}
exports.UpdateDefinedTypesVisitor = UpdateDefinedTypesVisitor;
//# sourceMappingURL=UpdateDefinedTypesVisitor.js.map