import type { IdlDefinedType } from '../idl';
import type { Node } from './Node';
import { TypeNode } from './TypeNode';
export type DefinedTypeNode = {
    readonly __definedTypeNode: unique symbol;
    readonly kind: 'definedTypeNode';
    readonly name: string;
    readonly data: TypeNode;
    readonly idlName: string;
    readonly docs: string[];
    readonly internal: boolean;
};
export type DefinedTypeNodeInput = {
    readonly name: string;
    readonly data: TypeNode;
    readonly idlName?: string;
    readonly docs?: string[];
    readonly internal?: boolean;
};
export declare function definedTypeNode(input: DefinedTypeNodeInput): DefinedTypeNode;
export declare function definedTypeNodeFromIdl(idl: Partial<IdlDefinedType>): DefinedTypeNode;
export declare function isDefinedTypeNode(node: Node | null): node is DefinedTypeNode;
export declare function assertDefinedTypeNode(node: Node | null): asserts node is DefinedTypeNode;
