import type { IdlTypeEnum } from '../idl';
import type { EnumVariantTypeNode } from './EnumVariantTypeNode';
import type { Node } from './Node';
import { NumberTypeNode } from './NumberTypeNode';
export type EnumTypeNode = {
    readonly __enumTypeNode: unique symbol;
    readonly kind: 'enumTypeNode';
    readonly variants: EnumVariantTypeNode[];
    readonly size: NumberTypeNode;
};
export declare function enumTypeNode(variants: EnumVariantTypeNode[], options?: {
    size?: NumberTypeNode;
}): EnumTypeNode;
export declare function enumTypeNodeFromIdl(idl: IdlTypeEnum): EnumTypeNode;
export declare function isScalarEnum(node: EnumTypeNode): boolean;
export declare function isDataEnum(node: EnumTypeNode): boolean;
export declare function isEnumTypeNode(node: Node | null): node is EnumTypeNode;
export declare function assertEnumTypeNode(node: Node | null): asserts node is EnumTypeNode;
