import type { Node } from './Node';
import { NumberTypeNode } from './NumberTypeNode';
export type NumberWrapper = {
    kind: 'DateTime';
} | {
    kind: 'SolAmount';
} | {
    kind: 'Amount';
    identifier: string;
    decimals: number;
};
export type NumberWrapperTypeNode = {
    readonly __numberWrapperTypeNode: unique symbol;
    readonly kind: 'numberWrapperTypeNode';
    readonly number: NumberTypeNode;
    readonly wrapper: NumberWrapper;
};
export declare function numberWrapperTypeNode(number: NumberTypeNode, wrapper: NumberWrapper): NumberWrapperTypeNode;
export declare function isNumberWrapperTypeNode(node: Node | null): node is NumberWrapperTypeNode;
export declare function assertNumberWrapperTypeNode(node: Node | null): asserts node is NumberWrapperTypeNode;
