import type { IdlTypeOption } from '../idl';
import type { Node } from './Node';
import { NumberTypeNode } from './NumberTypeNode';
import { TypeNode } from './TypeNode';
export type OptionTypeNode = {
    readonly __optionTypeNode: unique symbol;
    readonly kind: 'optionTypeNode';
    readonly child: TypeNode;
    readonly prefix: NumberTypeNode;
    readonly fixed: boolean;
    readonly idlOption: 'option' | 'coption';
};
export declare function optionTypeNode(child: TypeNode, options?: {
    readonly prefix?: NumberTypeNode;
    readonly fixed?: boolean;
    readonly idlOption?: OptionTypeNode['idlOption'];
}): OptionTypeNode;
export declare function optionTypeNodeFromIdl(idl: IdlTypeOption): OptionTypeNode;
export declare function isOptionTypeNode(node: Node | null): node is OptionTypeNode;
export declare function assertOptionTypeNode(node: Node | null): asserts node is OptionTypeNode;
