import type { IdlTypeStructField } from '../idl';
import type { Node } from './Node';
import { TypeNode } from './TypeNode';
import { ValueNode } from './ValueNode';
export type StructFieldTypeNode = {
    readonly __structFieldTypeNode: unique symbol;
    readonly kind: 'structFieldTypeNode';
    readonly name: string;
    readonly child: TypeNode;
    readonly docs: string[];
    readonly defaultsTo: {
        strategy: 'optional' | 'omitted';
        value: ValueNode;
    } | null;
};
export type StructFieldTypeNodeInput = {
    readonly name: string;
    readonly child: TypeNode;
    readonly docs?: string[];
    readonly defaultsTo?: StructFieldTypeNode['defaultsTo'];
};
export declare function structFieldTypeNode(input: StructFieldTypeNodeInput): StructFieldTypeNode;
export declare function structFieldTypeNodeFromIdl(idl: IdlTypeStructField): StructFieldTypeNode;
export declare function isStructFieldTypeNode(node: Node | null): node is StructFieldTypeNode;
export declare function assertStructFieldTypeNode(node: Node | null): asserts node is StructFieldTypeNode;
