import { TypeNode, ValueNode } from '../nodes';
export type AccountSeed = {
    kind: 'programId';
} | {
    kind: 'constant';
    type: TypeNode;
    value: ValueNode;
} | {
    kind: 'variable';
    name: string;
    type: TypeNode;
    docs: string[];
};
export declare const programSeed: () => AccountSeed;
export declare const constantSeed: (type: TypeNode, value: ValueNode) => AccountSeed;
export declare const stringConstantSeed: (value: string) => AccountSeed;
export declare const variableSeed: (name: string, type: TypeNode, docs?: string | string[]) => AccountSeed;
export declare const publicKeySeed: (name: string, docs?: string | string[]) => AccountSeed;
export declare const stringSeed: (name: string, docs?: string | string[]) => AccountSeed;
