import type * as nodes from '../nodes';
import { Visitor } from './Visitor';
export declare abstract class BaseDelegateVisitor<T, U> implements Visitor<U> {
    readonly visitor: Visitor<T>;
    constructor(visitor: Visitor<T>);
    abstract map(value: T): U;
    visitRoot(root: nodes.RootNode): U;
    visitProgram(program: nodes.ProgramNode): U;
    visitAccount(account: nodes.AccountNode): U;
    visitAccountData(accountData: nodes.AccountDataNode): U;
    visitInstruction(instruction: nodes.InstructionNode): U;
    visitInstructionAccount(instructionAccount: nodes.InstructionAccountNode): U;
    visitInstructionDataArgs(instructionDataArgs: nodes.InstructionDataArgsNode): U;
    visitInstructionExtraArgs(instructionExtraArgs: nodes.InstructionExtraArgsNode): U;
    visitDefinedType(definedType: nodes.DefinedTypeNode): U;
    visitError(error: nodes.ErrorNode): U;
    visitArrayType(arrayType: nodes.ArrayTypeNode): U;
    visitLinkType(linkType: nodes.LinkTypeNode): U;
    visitEnumType(enumType: nodes.EnumTypeNode): U;
    visitEnumEmptyVariantType(enumEmptyVariantType: nodes.EnumEmptyVariantTypeNode): U;
    visitEnumStructVariantType(enumStructVariantType: nodes.EnumStructVariantTypeNode): U;
    visitEnumTupleVariantType(enumTupleVariantType: nodes.EnumTupleVariantTypeNode): U;
    visitMapType(mapType: nodes.MapTypeNode): U;
    visitOptionType(optionType: nodes.OptionTypeNode): U;
    visitSetType(setType: nodes.SetTypeNode): U;
    visitStructType(structType: nodes.StructTypeNode): U;
    visitStructFieldType(structFieldType: nodes.StructFieldTypeNode): U;
    visitTupleType(tupleType: nodes.TupleTypeNode): U;
    visitBoolType(boolType: nodes.BoolTypeNode): U;
    visitBytesType(bytesType: nodes.BytesTypeNode): U;
    visitNumberType(numberType: nodes.NumberTypeNode): U;
    visitNumberWrapperType(numberWrapperType: nodes.NumberWrapperTypeNode): U;
    visitPublicKeyType(publicKeyType: nodes.PublicKeyTypeNode): U;
    visitStringType(stringType: nodes.StringTypeNode): U;
}
