import type * as nodes from '../nodes';
export interface Visitor<T = void> {
    visitRoot: (root: nodes.RootNode) => T;
    visitProgram: (program: nodes.ProgramNode) => T;
    visitAccount: (account: nodes.AccountNode) => T;
    visitAccountData: (accountData: nodes.AccountDataNode) => T;
    visitInstruction: (instruction: nodes.InstructionNode) => T;
    visitInstructionAccount: (instructionAccount: nodes.InstructionAccountNode) => T;
    visitInstructionDataArgs: (instructionDataArgs: nodes.InstructionDataArgsNode) => T;
    visitInstructionExtraArgs: (instructionExtraArgs: nodes.InstructionExtraArgsNode) => T;
    visitDefinedType: (definedType: nodes.DefinedTypeNode) => T;
    visitError: (error: nodes.ErrorNode) => T;
    visitArrayType: (arrayType: nodes.ArrayTypeNode) => T;
    visitLinkType: (linkType: nodes.LinkTypeNode) => T;
    visitEnumType: (enumType: nodes.EnumTypeNode) => T;
    visitEnumEmptyVariantType: (enumEmptyVariantType: nodes.EnumEmptyVariantTypeNode) => T;
    visitEnumStructVariantType: (enumStructVariantType: nodes.EnumStructVariantTypeNode) => T;
    visitEnumTupleVariantType: (enumTupleVariantType: nodes.EnumTupleVariantTypeNode) => T;
    visitMapType: (mapType: nodes.MapTypeNode) => T;
    visitOptionType: (optionType: nodes.OptionTypeNode) => T;
    visitSetType: (setType: nodes.SetTypeNode) => T;
    visitStructType: (structType: nodes.StructTypeNode) => T;
    visitStructFieldType: (structFieldType: nodes.StructFieldTypeNode) => T;
    visitTupleType: (tupleType: nodes.TupleTypeNode) => T;
    visitBoolType: (boolType: nodes.BoolTypeNode) => T;
    visitBytesType: (bytesType: nodes.BytesTypeNode) => T;
    visitNumberType: (numberType: nodes.NumberTypeNode) => T;
    visitNumberWrapperType: (numberWrapperType: nodes.NumberWrapperTypeNode) => T;
    visitPublicKeyType: (publicKeyType: nodes.PublicKeyTypeNode) => T;
    visitStringType: (stringType: nodes.StringTypeNode) => T;
}
export declare function visit<T>(node: nodes.Node, visitor: Visitor<T>): T;
