import * as nodes from '../../nodes';
import { ImportFrom } from '../../shared/ImportFrom';
import { BaseNodeVisitor } from '../BaseNodeVisitor';
export type CustomInstructionSerializerOptions = {
    name: string;
    importFrom: ImportFrom;
    extract: boolean;
    extractAs: string;
    extractedTypeShouldBeInternal: boolean;
};
export declare class UseCustomInstructionSerializerVisitor extends BaseNodeVisitor {
    readonly map: Record<string, CustomInstructionSerializerOptions>;
    constructor(map: Record<string, true | Partial<CustomInstructionSerializerOptions>>);
    visitProgram(program: nodes.ProgramNode): nodes.Node;
    visitInstruction(instruction: nodes.InstructionNode): nodes.Node;
}
